/** \page download Download

\section notice Notice 

Copyright ESIEE (2009-2011) 

m{{dot}}couprie{{a}}esiee{{dot}}fr

This software is an image processing library whose purpose is to be
used primarily for research and teaching.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software. You can use,
modify and/or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy,
modify and redistribute granted by the license, users are provided
only with a limited warranty and the software's author, the holder of
the economic rights, and the successive licensors have only limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading, using, modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean that it is complicated to manipulate, and that also
therefore means that it is reserved for developers and experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards
their requirements in conditions enabling the security of their
systems and/or data to be ensured and, more generally, to use and
operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license. You don't have to accept the License,
but note that nothing other than this License grants you permission to
use, propagate or modify any covered work.

\section download Download

The download is available either in source form or in binary packages
for the most popular Linux distributions. Microsoft Windows installer
is also available, but it's compiled less frequently. Note that
neither the source codes nor the binary packages are signed and so You
have to be cautious using them in a production environment. Also there
are numerous Python packages used by certain Pink operators. For
example PIL, Tkinter, vtk, etc. You CAN import Pink even ff these packages
are not present on the system. You will receive several messages. 

\section nomenclature Nomenclature

As of may 2011 there is only one version of Pink
available (0.9). It is using the rolling development model. The
packages carry the corresponding svn versions. For example
pink-0.9.r1001 means that the package has been generated from the
1001th svn revision. 

\section source_code Source Code

The source code is extracted from the main svn development repository
held currently on the servers of ESIEE Engineering. This svn
repository is not public. The package is generated weakly together
with the webpage, which is generated from the source code. Note that
the access rights to the repository are not strictly cared for, so the
packages are not signed. If you need a signed version of the package,
please contact one of the main developers.

The sources are accessible on <A
HREF="http://sourceforge.net/projects/pinkimage/files/">SourceForge
Pinkimage</A><br>.

\section binary_packages Binary Packages

The binary packages are generated by the OpenSuSE Build Service. They
are generated weakly directly from the source packages. As of may 2011
these packages neither include development functions nor the bash
front-end. Both can be compiled from the source packages, but then the
binary packages would have much more dependencies. As the binary
packages are built on line, there are no means to actually verify
their content. Only use these packages if You trust the OpenSuSE build
service. You can download binary packages for the following
distributions (both 32bit and 64bit versions): 
<ul> 
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/openSUSE_Tumbleweed">
  openSUSE Tumbleweed (this is a rolling distribution)</A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/openSUSE_11.3">OpenSuSE 11.3 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/openSUSE_11.4">OpenSuSE 11.4 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/openSUSE_Factory">OpenSuSE Factory </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/Debian_6.0">
  Debian 6.0 / Ubuntu 11.4 / Ubuntu 11.10 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/Fedora_14">
  Fedora_14 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/Fedora_15">
  Fedora_15 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/Mandriva_2010">
  Mandriva 2010 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/Mandriva_2010.1">
  Mandriva 2010.1 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/RedHat_RHEL-6">
  RedHat Enterprise Linux 6</A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/SLE_11">
  SuSE Linux Enterprise 11 </A>
  <li> <A HREF="http://download.opensuse.org/repositories/home:/bRbw8Q1roHyo/SLE_11_SP1">
  SuSE Linux Enterprise 11 SP1</A>
</ul>

Note: openSuSE 11.2, Fedora 12 and Fedora 13 has reached its end of life.

\section msvc Microsoft Windows installer

The Microsoft Windows version is compiled using Microsoft Visual
Studio 10. To be able to install it, first you need to install
the <A HREF="http://www.microsoft.com/download/en/details.aspx?displaylang=en&id=5555">
Microsoft Visual C++ 2010 Redistributable Package (x86) </A>. The
installer can be found
at <A HREF="https://sourceforge.net/projects/pinkimage/files/Microsoft%20Windows/">
SourceForge </A>.


\author UjoImro, 2011








 */
